## freemat 4.2+dfsg1

=== CMakeLists.txt ===
######## CMake debugging macro
MACRO(WRITE_OUT_ALL_VARIABLES)
SET(DstFile ${CMAKE_CURRENT_BINARY_DIR}/AllVariables.txt)

#MESSAGE("DEBUG -- Writing out all variables to file ${DstFile}")

FILE(WRITE ${DstFile} "")
GET_CMAKE_PROPERTY(VARS VARIABLES)
FOREACH(var ${VARS})
FILE(APPEND ${DstFile} "${var} \"${${var}}\"\n")
ENDFOREACH(var ${VARS})
ENDMACRO(WRITE_OUT_ALL_VARIABLES)
### End Debugging tools


PROJECT(FreeMat CXX C )

ENABLE_LANGUAGE(Fortran)
INCLUDE(FortranCInterface)

SET(CMAKE_FIND_ROOT_PATH ${CMAKE_FIND_ROOT_PATH} ${external_base}/Install)

SET(CPACK_PACKAGE_VERSION_MAJOR "4")
SET(CPACK_PACKAGE_VERSION_MINOR "2")
SET(CPACK_PACKAGE_VERSION_PATCH "")
SET(CPACK_PACKAGE_FILE_NAME "FreeMat-4.2")
SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "FreeMat 4.2")
SET(CPACK_PACKAGE_VERSION "4.2")
SET(VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")

CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/Modules)

SET( RESOURCEDIR "${CMAKE_INSTALL_PREFIX}/share/FreeMat-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}" )
#SET( CMAKE_VERBOSE_MAKEFILE TRUE )
SET( LOCAL_PATH ${PROJECT_SOURCE_DIR}/dependencies/bin ${PROJECT_BINARY_DIR} /mingw/lib INTERNAL )

IF( MSVC )
	ADD_DEFINITIONS( /Dsnprintf=_snprintf /DNOMINMAX /DFREEMAT_VERSION="${VERSION}" /DRESOURCEDIR="${RESOURCEDIR}")
	#	ADD_DEFINITIONS( /D_HAS_ITERATOR_DEBUGGING=0 /D_SECURE_SCL=0 )
ELSE( MSVC )
	ADD_DEFINITIONS( -DFREEMAT_VERSION="${VERSION}" -DRESOURCEDIR="${RESOURCEDIR}")
	SET(CMAKE_SHARED_MODULE_LINK_FLAGS "${CMAKE_SHARED_MODULE_LINK_FLAGS} -export-dynamic")
	SET(CMAKE_SHARED_MODULE_LINK_CXX_FLAGS "${CMAKE_SHARED_MODULE_LINK_CXX_FLAGS} -export-dynamic")
ENDIF( MSVC )

IF( MINGW )
#    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -shared-libgcc -shared-libstdc++")
ENDIF(MINGW)

ADD_DEFINITIONS(-D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS)


SET(QT_USE_QTNETWORK TRUE)
SET(QT_USE_QTXML TRUE)
SET(QT_USE_QTOPENGL TRUE)
SET(QT_USE_QTSVG TRUE)
SET(QT_USE_QTWEBKIT TRUE)

FIND_PACKAGE(Qt4 REQUIRED)

FIND_PACKAGE(PythonInterp REQUIRED)


ADD_DEFINITIONS( ${QT_DEFINITIONS} )
INCLUDE_DIRECTORIES( ${QT_INCLUDES} )

FIND_PACKAGE(OpenGL REQUIRED)

message("OpenGL include path is ${OPENGL_INCLUDE_DIR}")
if (APPLE)
# Broken
INCLUDE_DIRECTORIES("${OPENGL_INCLUDE_DIR}/Headers") 
else ()
INCLUDE_DIRECTORIES("${OPENGL_INCLUDE_DIR}/GL") 
endif ()

MACRO (QT4_GENERATE_UI infile outfile )
     GET_FILENAME_COMPONENT(infile ${infile} ABSOLUTE)

     ADD_CUSTOM_COMMAND(OUTPUT ${outfile}
        COMMAND ${QT_UIC_EXECUTABLE}
        ARGS -o ${outfile} ${infile}
        DEPENDS ${infile})

     MACRO_ADD_FILE_DEPENDENCIES(${infile} ${outfile})
ENDMACRO (QT4_GENERATE_UI)

SET(OPTIONAL_LIBS "")

OPTION( FORCE_SYSTEM_LIBS "Only use system libraries. Don't build third party libs." )

######################################################################
# External Project Setup
######################################################################

include(ExternalProject)
SET(external_base ${CMAKE_CURRENT_BINARY_DIR}/deps/base CACHE PATH "Path where external dependencies that were built are installed")
SET(CMAKE_FIND_ROOT_PATH ${external_base}/Install ${CMAKE_FIND_ROOT_PATH})

######################################################################
# PCRE Package
######################################################################

FIND_PACKAGE(PCRE)

if (PCRE_FOUND)
  ADD_DEFINITIONS( -DHAVE_PCRE)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${PCRE_LIBS})
  INCLUDE_DIRECTORIES(${PCRE_INCLUDE})
endif ()

######################################################################
# FFTW Package
######################################################################

FIND_PACKAGE(FFTW)

if (FFTW_FOUND)
  ADD_DEFINITIONS( -DHAVE_FFTW)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${FFTW_LIBS})
  INCLUDE_DIRECTORIES(${FFTW_INCLUDE})
endif ()

######################################################################
# FFTWF Package
######################################################################

FIND_PACKAGE(FFTWF)

if (FFTWF_FOUND)
  ADD_DEFINITIONS( -DHAVE_FFTWF)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${FFTWF_LIBS})
  INCLUDE_DIRECTORIES(${FFTWF_INCLUDE})
endif ()

######################################################################
# ZLIB Package
######################################################################

FIND_PACKAGE(ZLIB)

if (ZLIB_FOUND)
  ADD_DEFINITIONS( -DHAVE_ZLIB)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${ZLIB_LIBS})
  INCLUDE_DIRECTORIES(${ZLIB_INCLUDE})
endif()


######################################################################
# ARPACK Package
######################################################################

FIND_PACKAGE(ARPACK)

if (ARPACK_FOUND)
  ADD_DEFINITIONS(-DHAVE_ARPACK)
# Ugly, ugly hack
# Should be  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${ARPACK_LIBS})
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${ARPACK_LIBS} lapack_c)
endif()


######################################################################
# FFI Package
######################################################################

if (APPLE)
  FIND_PACKAGE(FFI)
  if (FFI_FOUND)
    SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${FFI_LIBS})
    INCLUDE_DIRECTORIES(${FFI_INCLUDE})
  else ()
    message(FATAL_ERROR "FreeMat requires libFFI to compile")
  endif()
else()
  include(FindPkgConfig)
  message("Searching for libffi package (required)")
  pkg_check_modules(FFI REQUIRED libffi)
  ADD_DEFINITIONS(-DHAVE_FFI)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${FFI_LDFLAGS})
  INCLUDE_DIRECTORIES(${FFI_INCLUDE_DIRS})
  message("Found libffi version ${FFI_VERSION} here ${FFI_LIBDIR}")
endif()

######################################################################
# SuiteSparse Package
######################################################################

FIND_PACKAGE(SUITESPARSE)

if (SuiteSparse_FOUND)
  ADD_DEFINITIONS(-DHAVE_SUITESPARSE)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${SUITESPARSE_LIBS})
  INCLUDE_DIRECTORIES(${SUITESPARSE_INCLUDE})
endif ()


######################################################################
# PORTAUDIO Package
######################################################################

FIND_PACKAGE(PORTAUDIO)

if (PORTAUDIO_FOUND)
  ADD_DEFINITIONS(-DHAVE_PORTAUDIO19)
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${PORTAUDIO_LIBS})
  INCLUDE_DIRECTORIES(${PORTAUDIO_INCLUDE})
endif()

######################################################################
# VTK Support
######################################################################
OPTION(USE_VTK "Build with VTK support?" OFF)
IF (USE_VTK)
FIND_PACKAGE(VTK)
IF (VTK_FOUND)
  ADD_DEFINITIONS( -DHAVE_VTK )
  INCLUDE(${VTK_USE_FILE})
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} QVTK vtkFiltering vtkRendering vtkVolumeRendering vtkGraphics vtkIO vtkCommon vtkGeovis vtkImaging vtkInfovis vtkWidgets vtkHybrid vtkParallel)
ENDIF (VTK_FOUND)
ENDIF (USE_VTK)

######################################################################
# ITK Support
######################################################################
OPTION(USE_ITK "Build with InsightToolkit support?" OFF)
IF (USE_ITK)
FIND_PACKAGE(ITK)
IF (ITK_FOUND)
  ADD_DEFINITIONS( -DHAVE_ITK)
  INCLUDE(${ITK_USE_FILE})
  SET(OPTIONAL_LIBS ${OPTIONAL_LIBS} ITKBasicFilters)
ENDIF(ITK_FOUND)
ENDIF(USE_ITK)

######################################################################
# Boost Support
######################################################################
find_package( Boost COMPONENTS math_c99 )
if(Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
  add_definitions(-DHAVE_BOOST)
  set(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${Boost_LIBRARIES})
endif()

######################################################################
# LLVM Support
######################################################################
OPTION(USE_LLVM "Build with LLVM support?" ON)

FIND_PACKAGE(LLVM)
FIND_PACKAGE(CLANG)

IF (LLVM_FOUND AND CLANG_FOUND)
  add_definitions(-DHAVE_LLVM)
  include_directories(${LLVM_INCLUDE_DIRS})
  link_directories(${LLVM_LIBRARY_DIRS})
  llvm_map_components_to_libraries(REQ_LLVM_LIBRARIES jit interpreter nativecodegen asmparser bitreader bitwriter codegen ipo linker selectiondag instrumentation)
  set(OPTIONAL_LIBS ${OPTIONAL_LIBS} ${CLANG_LIBRARIES} ${REQ_LLVM_LIBRARIES})
ENDIF()

##############################################################################
#Extra libraries
IF(NOT WIN32)
  FIND_LIBRARY(NCURSES_LIBRARY NAMES ncurses DOC "Location of the ncurses library." PATH /mingw/lib)
  SET(EXTRA_LIBRARIES ${NCURSES_LIBRARY}  )
ENDIF(NOT WIN32)

INCLUDE_DIRECTORIES( libs/libFreeMat libs/libGraphics
libs/libMex libs/libXP libs/libCore libs/libFN libs/libMatC
libs/libMath/libDynBlas ${QT_LIBRARIES} src toolbox/jit)


##############################################################################
# BLAS is always linked dynamically
ADD_DEFINITIONS( -DDYN_BLAS )


if( MSVC )
  add_definitions( -D_CRT_SECURE_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS )
  add_definitions( -D_SCL_SECURE_NO_WARNINGS -DCRT_NONSTDC_NO_WARNINGS )
  add_definitions( -D_SCL_SECURE_NO_DEPRECATE )
  #add_definitions( -wd4146 -wd4503 -wd4996 -wd4800 -wd4244 -wd4624 )
  #add_definitions( -wd4355 -wd4715 )
endif( MSVC )

ADD_SUBDIRECTORY( libs )
ADD_SUBDIRECTORY( src )

####################################################################################
#Install section
#IF( WIN32 )
#	FILE(GLOB INST_DLL "dependencies/bin/*.dll" )
#	INSTALL(FILES ${INST_DLL} DESTINATION bin )
#ENDIF( WIN32 )
#
####################################################################################
#Setup section

INCLUDE(InstallRequiredSystemLibraries)

GET_TARGET_PROPERTY(FreeMat_Loc FreeMat LOCATION)
# Do not run helpgen automatically -- there are too many things that
# have to be checked after it is run.
#INSTALL( CODE "EXECUTE_PROCESS( COMMAND ${FreeMat_Loc} -f run_helpgen WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})" )
#INSTALL(DIRECTORY toolbox DESTINATION share/FreeMat PATTERN "*.m" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
#INSTALL(DIRECTORY help DESTINATION share/FreeMat PATTERN "*" PERMISSIONS WORLD_READ )

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "FreeMat")

SET(CPACK_RESOURCE_FILE_LICENSE ${PROJECT_SOURCE_DIR}/COPYING)
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "FreeMat is a free environment for rapid engineering and scientific prototyping and data processing.")

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "FreeMat")

IF(UNIX AND NOT WIN32 AND NOT APPLE)
  SET(INST_DIR "share/FreeMat-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
  INSTALL(DIRECTORY toolbox DESTINATION ${INST_DIR} PATTERN "*" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
  INSTALL(DIRECTORY tests DESTINATION ${INST_DIR}/toolbox PATTERN "*" PATTERN ".svn" EXCLUDE PATTERN "CMakeLists.txt" EXCLUDE PERMISSIONS WORLD_READ )
  INSTALL(DIRECTORY help/html DESTINATION "${INST_DIR}/help" PATTERN "*" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
  INSTALL(DIRECTORY help/text DESTINATION "${INST_DIR}/help" PATTERN "*" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
  INSTALL(FILES "help/latex/FreeMat-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.pdf" DESTINATION "${INST_DIR}/help/pdf" )
ENDIF(UNIX AND NOT WIN32 AND NOT APPLE)

IF(WIN32)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  #SET(CPACK_PACKAGE_ICON "${CMake_SOURCE_DIR}/Utilities/Release\\\\InstallIcon.bmp")
  SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\FreeMat.exe")
  SET(CPACK_NSIS_DISPLAY_NAME "FreeMat")
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\freemat.sf.net")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\freemat.sf.net")
  #SET(CPACK_NSIS_CONTACT "me@my-personal-home-page.com")
  #SET(CPACK_NSIS_MODIFY_PATH ON)

  INSTALL(FILES
	${QT_LIBRARY_DIR}/QtCore4.dll
	${QT_LIBRARY_DIR}/QtGui4.dll
	${QT_LIBRARY_DIR}/QtNetwork4.dll
	${QT_LIBRARY_DIR}/QtOpenGL4.dll
	${QT_LIBRARY_DIR}/QtXml4.dll

=== src/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR}  ${QT_QTNETWORK_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTOPENGL_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES( "${CMAKE_CURRENT_BINARY_DIR}/../libs/libXP")

QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/application.hpp ${CMAKE_CURRENT_BINARY_DIR}/application.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/FuncMode.hpp ${CMAKE_CURRENT_BINARY_DIR}/FuncMode.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/ScriptMode.hpp ${CMAKE_CURRENT_BINARY_DIR}/ScriptMode.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/MainApp.hpp ${CMAKE_CURRENT_BINARY_DIR}/MainApp.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/Terminal.hpp ${CMAKE_CURRENT_BINARY_DIR}/Terminal.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/DumbTerminal.hpp ${CMAKE_CURRENT_BINARY_DIR}/DumbTerminal.moc.cpp )

QT4_ADD_RESOURCES( FreeMat_qrc ${CMAKE_CURRENT_SOURCE_DIR}/FreeMat.qrc  )

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
	DEPENDS MainApp.cpp
	COMMAND ${PYTHON_EXECUTABLE}
	ARGS ${CMAKE_SOURCE_DIR}/tools/siggen.py ${CMAKE_CURRENT_SOURCE_DIR} Main ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating function signatures"
	VERBATIM
	)

ADD_EXECUTABLE( FreeMat MACOSX_BUNDLE WIN32
${CMAKE_CURRENT_BINARY_DIR}/application.moc.cpp
application.cpp
${CMAKE_CURRENT_BINARY_DIR}/FuncMode.moc.cpp
${CMAKE_CURRENT_BINARY_DIR}/ScriptMode.moc.cpp
FuncMode.cpp
ScriptMode.cpp
FuncTerminal.cpp
${CMAKE_CURRENT_BINARY_DIR}/MainApp.moc.cpp
MainApp.cpp
main.cpp
${CMAKE_CURRENT_BINARY_DIR}/DumbTerminal.moc.cpp
DumbTerminal.cpp
${CMAKE_CURRENT_BINARY_DIR}/Terminal.moc.cpp
${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
Terminal.cpp
${FreeMat_qrc}
freemat.rc
# Added per: http://www.cmake.org/pipermail/cmake/2010-July/038172.html
dummy.f
)

#${X86TARGET_OBJ}

#IF( MSVC )
#	SET( LAPACK_LIBRARY ${lapack} )
#ENDIF( MSVC )

IF( USE_DYNLINK )
	TARGET_LINK_LIBRARIES( FreeMat blas )
ENDIF( USE_DYNLINK )


if (USE_VTK)
set (VTK_WRAPPER_LIBS
vtkCommonWrapper        vtkIOWrapper
vtkFilteringWrapper  vtkParallelWrapper
vtkGeovisWrapper        vtkRenderingWrapper
vtkGraphicsWrapper    vtkViewsWrapper
vtkHybridWrapper        vtkVolumeRenderingWrapper
vtkImagingWrapper      vtkWidgetsWrapper
vtkInfovisWrapper )
endif (USE_VTK)

if (USE_ITK)
set (ITK_WRAPPER_LIBS itkWrapper)
endif (USE_ITK)

TARGET_LINK_LIBRARIES( FreeMat
Core
FN
${VTK_WRAPPER_LIBS}
${ITK_WRAPPER_LIBS}
Graphics
FreeMatlib
XP
Mex
MatC
levmar
lapack_c
dynblas
blasref
${QT_QTCORE_LIBRARY}
${QT_QTGUI_LIBRARY}
${QT_QTNETWORK_LIBRARY}
${QT_QTOPENGL_LIBRARY}
${QT_QTXML_LIBRARY}
${QT_QTSVG_LIBRARY}
${QT_QTMAIN_LIBRARY}
${QT_QTWEBKIT_LIBRARY}
${OPENGL_LIBRARIES}
${EXTRA_LIBRARIES}
${OPTIONAL_LIBS}
)


#IF(MSVC)
#  SET_TARGET_PROPERTIES(FreeMat PROPERTIES LINK_FLAGS "/INCLUDE:_X86TargetMachineModule")
#ENDIF(MSVC)

#IF( MSVC )
#	set_target_properties( FreeMat PROPERTIES LINK_FLAGS "/MANIFEST:NO  /ALLOWISOLATION:NO" )
#ENDIF( MSVC )

INSTALL(TARGETS FreeMat BUNDLE DESTINATION . COMPONENT Runtime
		RUNTIME DESTINATION bin COMPONENT Runtime)

# Mac OS X specific packaging info
IF(APPLE)
SET(MACOSX_BUNDLE_ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/appIcon.icns)
SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/appIcon.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

#  SET(CPACK_BUNDLE_PLIST ${PROJECT_SOURCE_DIR}/tools/Info.plist )
#  SET(CPACK_BUNDLE_STARTUP_COMMAND ${PROJECT_BINARY_DIR}/src/FreeMat )
#  SET(CPACK_BUNDLE_NAME "FreeMat")
#  SET(CPACK_BUNDLE_ICON ${PROJECT_SOURCE_DIR}/src/appIcon.icns)

SET(plugin_dest_dir bin)
SET(qtconf_dest_dir bin)
SET(APPS "\${CMAKE_INSTALL_PREFIX}/bin/FreeMat")
IF(APPLE)
  SET(plugin_dest_dir FreeMat.app/Contents)
  SET(qtconf_dest_dir FreeMat.app/Contents/Resources)
  SET(APPS "\${CMAKE_INSTALL_PREFIX}/FreeMat.app")
ENDIF(APPLE)
IF(WIN32)
  SET(APPS "\${CMAKE_INSTALL_PREFIX}/bin/FreeMat.exe")
ENDIF(WIN32)


#--------------------------------------------------------------------------------
# Install needed Qt plugins by copying directories from the qt installation
# One can cull what gets copied by using 'REGEX "..." EXCLUDE'
INSTALL(DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION ${plugin_dest_dir}/plugins COMPONENT Runtime)

#--------------------------------------------------------------------------------
# install a qt.conf file
# this inserts some cmake code into the install script to write the file
INSTALL(CODE "
    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${qtconf_dest_dir}/qt.conf\" \"\")
    " COMPONENT Runtime)


#--------------------------------------------------------------------------------
# Use BundleUtilities to get all other dependencies for the application to work.
# It takes a bundle or executable along with possible plugins and inspects it
# for dependencies.  If they are not system dependencies, they are copied.

# directories to look for dependencies
SET(DIRS ${QT_LIBRARY_DIRS})

# Now the work of copying dependencies into the bundle/package
# The quotes are escaped and variables to use at install time have their $ escaped
# An alternative is the do a configure_file() on a script and use install(SCRIPT  ...).
# Note that the image plugins depend on QtSvg and QtXml, and it got those copied
# over.
INSTALL(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
    " COMPONENT Runtime)


# To Create a package, one can run "cpack -G DragNDrop CPackConfig.cmake" on Mac OS X
# where CPackConfig.cmake is created by including CPack
# And then there's ways to customize this as well
set(CPACK_BINARY_DRAGNDROP ON)

INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/toolbox DESTINATION ${qtconf_dest_dir} PATTERN "*" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/tests DESTINATION ${qtconf_dest_dir}/toolbox PATTERN "*" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/help/html DESTINATION ${qtconf_dest_dir}/help PATTERN "*" PATTERN ".svn" EXCLUDE PERMISSIONS WORLD_READ )
INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/help/text DESTINATION ${qtconf_dest_dir}/help PATTERN "*" PATTERN  ".svn" EXCLUDE PERMISSIONS WORLD_READ )
INSTALL(FILES
"${CMAKE_SOURCE_DIR}/help/latex/FreeMat-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.pdf"
 DESTINATION "${qtconf_dest_dir}/help/pdf" )
INSTALL(FILES
"${CMAKE_SOURCE_DIR}/help/latex/FreeMat-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.pdf"
 DESTINATION ".")

#INSTALL(DIRECTORY /opt/local/lib/Resources/qt_menu.nib DESTINATION ${qtconf_dest_dir} COMPONENT Runtime)

ENDIF(APPLE)

if (APPLE)
INSTALL( FILES ${PROJECT_SOURCE_DIR}/tools/blas.ini DESTINATION FreeMat.app/Contents/MacOS)
else()
INSTALL( FILES ${PROJECT_SOURCE_DIR}/tools/blas.ini DESTINATION bin )
endif()


#Ideally, these would be found automatically
IF(WIN32 AND CMAKE_CROSSCOMPILING)
message("Cross compiling and installing")
FIND_LIBRARY(INST_PCRE_LIB NAMES libpcre-1.dll)
FIND_LIBRARY(INST_FFI_LIB NAMES libffi-6.dll)
FIND_LIBRARY(INST_GFORTRAN_LIB NAMES libgfortran-3.dll)
FIND_LIBRARY(INST_PORTAUDIO_LIB NAMES libportaudio-2.dll)
FIND_LIBRARY(INST_QUADMATH_LIB NAMES libquadmath-0.dll)
FIND_LIBRARY(INST_JPEG_LIB NAMES libjpeg-62.dll)
FIND_LIBRARY(INST_TIFF_LIB NAMES libtiff-3.dll)
INSTALL(FILES ${INST_PCRE_LIB} DESTINATION bin COMPONENT Runtime)
INSTALL(FILES ${INST_FFI_LIB} DESTINATION bin COMPONENT Runtime)
INSTALL(FILES ${INST_GFORTRAN_LIB} DESTINATION bin COMPONENT Runtime)
INSTALL(FILES ${INST_PORTAUDIO_LIB} DESTINATION bin COMPONENT Runtime)
INSTALL(FILES ${INST_QUADMATH_LIB} DESTINATION bin COMPONENT Runtime)
INSTALL(FILES ${INST_JPEG_LIB} DESTINATION bin COMPONENT Runtime)
INSTALL(FILES ${INST_TIFF_LIB} DESTINATION bin COMPONENT Runtime)
ENDIF()


WRITE_OUT_ALL_VARIABLES()

=== tests/CMakeLists.txt ===
ENABLE_TESTING()
add_subdirectory(glwin)
add_subdirectory(vtkfiltering)
add_subdirectory(curvefit)
add_subdirectory(flow)
add_subdirectory(variables)
add_subdirectory(random)
add_subdirectory(num)
add_subdirectory(transforms)
add_subdirectory(io)
add_subdirectory(elementary)
add_subdirectory(array)
add_subdirectory(vtkio)
add_subdirectory(binary)
add_subdirectory(functions)
add_subdirectory(typecast)
add_subdirectory(vtkcommon)
add_subdirectory(introduction)
add_subdirectory(vtkimaging)
add_subdirectory(vtkviews)
add_subdirectory(function)
add_subdirectory(handle)
add_subdirectory(string)
add_subdirectory(vtkgraphics)
add_subdirectory(operators)
add_subdirectory(vtkrendering)
add_subdirectory(vtkhybrid)
add_subdirectory(external)
add_subdirectory(freemat)
add_subdirectory(class)
add_subdirectory(constants)
add_subdirectory(vtkinfovis)
add_subdirectory(thread)
add_subdirectory(inspection)
add_subdirectory(signal)
add_subdirectory(vtkparallel)
add_subdirectory(mathfunctions)
add_subdirectory(vtkwidgets)
add_subdirectory(vtkvolumerendering)
add_subdirectory(sparse)
add_subdirectory(vtkgeovis)
add_subdirectory(debug)
add_subdirectory(os)
add_subdirectory(jit)
add_subdirectory(itk)

=== help/latex/Makefile ===
all: refman.pdf

pdf: refman.pdf

refman.pdf: clean refman.tex
	pdflatex refman
	makeindex refman.idx
	pdflatex refman
	latex_count=5 ; \
	while egrep -s 'Rerun (LaTeX|to get cross-references right)' refman.log && [ $$latex_count -gt 0 ] ;\
	    do \
	      echo "Rerunning latex...." ;\
	      pdflatex refman ;\
	      latex_count=`expr $$latex_count - 1` ;\
	    done


clean:
	rm -f *.ps *.dvi *.aux *.toc *.idx *.ind *.ilg *.log *.out *.brf *.blg *.bbl refman.pdf

=== libs/libCore/CMakeLists.txt ===

INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR}  ${QT_QTNETWORK_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/helpwidget.hpp ${CMAKE_CURRENT_BINARY_DIR}/helpwidget.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/XML.hpp ${CMAKE_CURRENT_BINARY_DIR}/XML.moc.cpp )

set(CORE_SOURCES
Abs.cpp 
Binary.cpp 
Ceil.cpp 
Conj.cpp 
CumProd.cpp 
CumSum.cpp 
Dot.cpp
Floor.cpp 
Max.cpp 
Min.cpp 
Prod.cpp 
RCond.cpp 
Round.cpp 
Sum.cpp 
Time.cpp 
Variance.cpp 
RealImag.cpp 
Sort.cpp 
Unique.cpp 
XNorm.cpp 
Analyze.cpp 
Cast.cpp 
Constants.cpp 
Reshape.cpp 
Zeros.cpp 
Ones.cpp 
Cell.cpp 
Struct.cpp 
Directory.cpp 
FFT.cpp 
helpwidget.cpp 
Help.cpp 
Hex.cpp 
Clear.cpp 
Exist.cpp 
Find.cpp 
Is.cpp 
Size.cpp 
Path.cpp 
Inspect.cpp 
Audio.cpp 
Random.cpp 
RanLib.cpp 
Image.cpp 
File.cpp 
Printf.cpp 
IO.cpp 
Conv.cpp 
Eval.cpp 
Debug.cpp 
LU.cpp 
QR.cpp 
Eigen.cpp 
SVD.cpp 
Array.cpp 
Version.cpp 
Error.cpp 
Misc.cpp 
Mean.cpp 
StringOps.cpp 
Transcendental.cpp 
Trigonometric.cpp 
Utils.cpp 
MatIO.cpp 
XML.cpp 
Cstruct.cpp 
Control.cpp 
Sparse.cpp 
Matrix.cpp )



add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
	DEPENDS ${CORE_SOURCES}
	COMMAND ${PYTHON_EXECUTABLE}
	ARGS ${CMAKE_SOURCE_DIR}/tools/siggen.py
	${CMAKE_CURRENT_SOURCE_DIR} Core ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating function signatures"
	VERBATIM
	)

ADD_LIBRARY( Core 
${CORE_SOURCES}
${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
${CMAKE_CURRENT_BINARY_DIR}/helpwidget.moc.cpp
${CMAKE_CURRENT_BINARY_DIR}/XML.moc.cpp )

=== libs/libFreeMat/CMakeLists.txt ===

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR} ${LOCAL_PATH} )

QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/Interpreter.hpp ${CMAKE_CURRENT_BINARY_DIR}/Intrepreter.moc.cpp)
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/DebugStream.hpp ${CMAKE_CURRENT_BINARY_DIR}/DebugStream.moc.cpp )

set (FREEMAT_SOURCES
Array.cpp 
Algorithms.cpp 
Interpreter.cpp 
Context.cpp 
EigenDecompose.cpp 
Exception.cpp 
File.cpp 
IEEEFP.cpp 
IndexArray.cpp 
LAPACK.cpp 
LeastSquaresSolver.cpp 
LinearEqSolver.cpp 
LUDecompose.cpp 
Math.cpp 
MatrixMultiply.cpp 
Module.cpp 
Scope.cpp 
Serialize.cpp 
SparseMatrix.cpp 
Class.cpp 
Print.cpp 
Token.cpp 
Parser.cpp 
OctaveScanner.cpp 
Scanner.cpp 
Tree.cpp 
FunctionDef.cpp 
FuncPtr.cpp 
AnonFunc.cpp 
SparseCCS.cpp 
Stats.cpp
Struct.cpp
)

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
	DEPENDS ${FREEMAT_SOURCES}
	COMMAND ${PYTHON_EXECUTABLE}
	ARGS ${CMAKE_SOURCE_DIR}/tools/siggen.py ${CMAKE_CURRENT_SOURCE_DIR} FreeMat ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating function signatures"
	VERBATIM
	)
 
ADD_LIBRARY( FreeMatlib 
${FREEMAT_SOURCES}
${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
${CMAKE_CURRENT_BINARY_DIR}/Intrepreter.moc.cpp
DebugStream.cpp
${CMAKE_CURRENT_BINARY_DIR}/DebugStream.moc.cpp
)

=== libs/libGraphics/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR} ${QT_QTOPENGL_INCLUDE_DIR} ${QT_QTSVG_INCLUDE_DIR} )

QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/HandleUIControl.hpp ${CMAKE_CURRENT_BINARY_DIR}/HandleUIControl.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/HandleMultiEdit.hpp ${CMAKE_CURRENT_BINARY_DIR}/HandleMultiEdit.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/HandleWindow.hpp ${CMAKE_CURRENT_BINARY_DIR}/HandleWindow.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/GLWindow.hpp ${CMAKE_CURRENT_BINARY_DIR}/GLWindow.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/VTKWindow.hpp ${CMAKE_CURRENT_BINARY_DIR}/VTKWindow.moc.cpp )


if (USE_VTK)

ADD_EXECUTABLE (vtkWrapFreeMat
${CMAKE_SOURCE_DIR}/tools/vtkwrap/vtkWrapFreeMat.c
${CMAKE_SOURCE_DIR}/tools/vtkwrap/vtkParse.tab.c)

ADD_SUBDIRECTORY(vtk)

endif(USE_VTK)

if (USE_ITK)
ADD_SUBDIRECTORY(itk)
endif(USE_ITK)

set (VTK_WRAPPER_LIBS 
vtkCommonWrapper        vtkIOWrapper
vtkFilteringWrapper  vtkParallelWrapper
vtkGeovisWrapper        vtkRenderingWrapper
vtkGraphicsWrapper    vtkViewsWrapper
vtkHybridWrapper        vtkVolumeRenderingWrapper
vtkImagingWrapper      vtkWidgetsWrapper
vtkInfovisWrapper)


set( GRAPHICS_SOURCES
GLRenderEngine.cpp 
HandleAxis.cpp 
HandleCommands.cpp 
HandleContour.cpp 
HandleFigure.cpp 
HandleImage.cpp 
HandleLineSeries.cpp 
HandleObject.cpp 
HandleProperty.cpp 
HandleSurface.cpp 
HandlePatch.cpp
HandleText.cpp 
HandleWindow.cpp 
QTRenderEngine.cpp 
RenderEngine.cpp 
HandleUIControl.cpp 
HandleMultiEdit.cpp 
GLWindow.cpp
trackball.cpp
VTKWindow.cpp
VTKWrap.cpp
)

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
	DEPENDS ${GRAPHICS_SOURCES}
	COMMAND ${PYTHON_EXECUTABLE}
	ARGS ${CMAKE_SOURCE_DIR}/tools/siggen.py
	${CMAKE_CURRENT_SOURCE_DIR} Graphics ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating function signatures"
	VERBATIM
	)


ADD_LIBRARY( Graphics 
${GRAPHICS_SOURCES}
${CMAKE_CURRENT_BINARY_DIR}/Loader.cpp
${CMAKE_CURRENT_BINARY_DIR}/VTKWindow.moc.cpp
${CMAKE_CURRENT_BINARY_DIR}/HandleUIControl.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/HandleMultiEdit.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/HandleWindow.moc.cpp
${CMAKE_CURRENT_BINARY_DIR}/GLWindow.moc.cpp
)

=== libs/libMatC/CMakeLists.txt ===

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR} )

ADD_LIBRARY( MatC 
	JITFactory.cpp
	CJitFunc.cpp
	CJitFuncClang.cpp
	CArray.cpp
)

# Uncommenting for now... needs work
#ADD_DEPENDENCIES(MatC jitgen)

=== libs/libMath/CMakeLists.txt ===
ADD_SUBDIRECTORY(libLAPACK_C)
ADD_SUBDIRECTORY(libDynBlas)
ADD_SUBDIRECTORY(libBLAS_C)

=== libs/libXP/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR} )


ADD_LIBRARY( XP 
DynLib.cpp 
KeyManager.cpp 
PathSearch.cpp 
QTTerm.cpp 
System.cpp 
Editor.cpp 
FMFontDialog.cpp
PathTool.cpp 
highlighter.cpp 
FileTool.cpp 
Common.cpp 
ToolDock.cpp 
VariablesTool.cpp 
HistoryWidget.cpp 
DebugWin.cpp
DataTable.cpp
StackTool.cpp
${CMAKE_CURRENT_BINARY_DIR}/fontform.ui.h
${CMAKE_CURRENT_BINARY_DIR}/findform.ui.h
${CMAKE_CURRENT_BINARY_DIR}/replaceform.ui.h 
${CMAKE_CURRENT_BINARY_DIR}/synlightconf.ui.h 
${CMAKE_CURRENT_BINARY_DIR}/indentconf.ui.h 
${CMAKE_CURRENT_BINARY_DIR}/KeyManager.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/QTTerm.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/Editor.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/FMFontDialog.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/PathTool.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/highlighter.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/VariablesTool.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/FileTool.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/HistoryWidget.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/ToolDock.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/DebugWin.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/DataTable.moc.cpp 
${CMAKE_CURRENT_BINARY_DIR}/StackTool.moc.cpp
)

QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/KeyManager.hpp ${CMAKE_CURRENT_BINARY_DIR}/KeyManager.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/QTTerm.hpp ${CMAKE_CURRENT_BINARY_DIR}/QTTerm.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/Editor.hpp ${CMAKE_CURRENT_BINARY_DIR}/Editor.moc.cpp ) 
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/FMFontDialog.hpp ${CMAKE_CURRENT_BINARY_DIR}/FMFontDialog.moc.cpp ) 
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/PathTool.hpp ${CMAKE_CURRENT_BINARY_DIR}/PathTool.moc.cpp )  
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/highlighter.hpp ${CMAKE_CURRENT_BINARY_DIR}/highlighter.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/VariablesTool.hpp ${CMAKE_CURRENT_BINARY_DIR}/VariablesTool.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/FileTool.hpp ${CMAKE_CURRENT_BINARY_DIR}/FileTool.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/HistoryWidget.hpp ${CMAKE_CURRENT_BINARY_DIR}/HistoryWidget.moc.cpp )  
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/ToolDock.hpp ${CMAKE_CURRENT_BINARY_DIR}/ToolDock.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/VariablesTool.hpp ${CMAKE_CURRENT_BINARY_DIR}/VariablesTool.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/DebugWin.hpp ${CMAKE_CURRENT_BINARY_DIR}/DebugWin.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/DataTable.hpp ${CMAKE_CURRENT_BINARY_DIR}/DataTable.moc.cpp )
QT4_GENERATE_MOC( ${CMAKE_CURRENT_SOURCE_DIR}/StackTool.hpp ${CMAKE_CURRENT_BINARY_DIR}/StackTool.moc.cpp )

QT4_GENERATE_UI( ${CMAKE_CURRENT_SOURCE_DIR}/findform.ui ${CMAKE_CURRENT_BINARY_DIR}/findform.ui.h )
QT4_GENERATE_UI( ${CMAKE_CURRENT_SOURCE_DIR}/replaceform.ui ${CMAKE_CURRENT_BINARY_DIR}/replaceform.ui.h )
QT4_GENERATE_UI( ${CMAKE_CURRENT_SOURCE_DIR}/synlightconf.ui ${CMAKE_CURRENT_BINARY_DIR}/synlightconf.ui.h )  
QT4_GENERATE_UI( ${CMAKE_CURRENT_SOURCE_DIR}/indentconf.ui ${CMAKE_CURRENT_BINARY_DIR}/indentconf.ui.h )
QT4_GENERATE_UI( ${CMAKE_CURRENT_SOURCE_DIR}/fontform.ui ${CMAKE_CURRENT_BINARY_DIR}/fontform.ui.h )

=== tests/array/CMakeLists.txt ===
ENABLE_TESTING()
ADD_TEST(wbtest_transpose_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=transpose(x1)','wbtest_transpose_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_expm_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=expm(x1)#(any(loopi==[50:51]))','wbtest_expm_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_rref_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=rref(x1)','wbtest_rref_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_rref_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#[y1,y2]=rref(x1)','wbtest_rref_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_rref_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#[y1,y2]=rref(x1,.0001)#(any(loopi==[15,62]))','wbtest_rref_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_norm_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=norm(x1)#(any(loopi==[50:51]))','wbtest_norm_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_norm_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=norm(x1,1)','wbtest_norm_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_norm_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=norm(x1,2)#(any(loopi==[50:51]))','wbtest_norm_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_norm_4 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=norm(x1,7)','wbtest_norm_4','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_norm_5 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=norm(x1,inf)','wbtest_norm_5','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_norm_6 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=norm(x1,-inf)','wbtest_norm_6','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_rank_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=rank(x1)','wbtest_rank_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_rank_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=rank(x1,.0001)','wbtest_rank_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(test_det1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_det1')")
ADD_TEST(wbtest_det_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=det(x1)','wbtest_det_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_cond_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=cond(x1)','wbtest_cond_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_eye_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=eye(3)','wbtest_eye_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_eye_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=eye(300)','wbtest_eye_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_pinv_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=pinv(x1)','wbtest_pinv_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(test_isfloat1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_isfloat1')")
ADD_TEST(wbtest_nonzeros_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=nonzeros(x1)','wbtest_nonzeros_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_ndgrid_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#[y1,y2] = ndgrid(1:2,3:5)','wbtest_ndgrid_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_ndgrid_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#[y1,y2,y3] = ndgrid(1:2,3:5,0:1)','wbtest_ndgrid_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_ndgrid_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#[y1,y2,y3] = ndgrid(1:3)','wbtest_ndgrid_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_logspace_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=logspace(1,2)','wbtest_logspace_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_logspace_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=logspace(1,2,3)','wbtest_logspace_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_logspace_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#y1=logspace(0,pi,3)','wbtest_logspace_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_squeeze_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=squeeze(x1)','wbtest_squeeze_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_flipud_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=flipud(x1)','wbtest_flipud_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(test_isinteger1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_isinteger1')")
ADD_TEST(wbtest_linspace_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#z=linspace(0,60000,60001);y1=z(end)','wbtest_linspace_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_linspace_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=linspace(0,1)','wbtest_linspace_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_linspace_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=linspace(1,91,91)','wbtest_linspace_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_fliplr_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=fliplr(x1)','wbtest_fliplr_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_flipdim_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=flipdim(x1,1)','wbtest_flipdim_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_flipdim_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=flipdim(x1,2)','wbtest_flipdim_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_flipdim_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=flipdim(x1,3)','wbtest_flipdim_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_meshgrid_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$near#[y1,y2] = meshgrid(-2:.4:2)','wbtest_meshgrid_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_meshgrid_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#[y1,y2] = meshgrid([1,2,3,4],[6,7,8])','wbtest_meshgrid_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_ipermute_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=ipermute(x1,[2,1])','wbtest_ipermute_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_ipermute_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=size(ipermute(permute(x1),[3,4,2,1]),[3,4,2,1])','wbtest_ipermute_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[1,0])','wbtest_circshift_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[0,-1])','wbtest_circshift_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[2,2])','wbtest_circshift_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_4 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[1,0,0])','wbtest_circshift_4','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_5 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[0,-1,0])','wbtest_circshift_5','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_6 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[0,0,-1])','wbtest_circshift_6','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_circshift_7 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=circshift(x1,[2,-3,1])','wbtest_circshift_7','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_shiftdim_1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=shiftdim(x1,1)','wbtest_shiftdim_1','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_shiftdim_2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#y1=shiftdim(x1,-1)','wbtest_shiftdim_2','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(wbtest_shiftdim_3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wb_test('@$exact#[y1,y2]=shiftdim(x1)','wbtest_shiftdim_3','${CMAKE_SOURCE_DIR}/tests/reference')")
ADD_TEST(test_assign1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign1')")
ADD_TEST(test_assign2 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign2')")
ADD_TEST(test_assign3 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign3')")
ADD_TEST(test_assign4 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign4')")
ADD_TEST(test_assign5 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign5')")
ADD_TEST(test_assign6 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign6')")
ADD_TEST(test_assign7 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign7')")
ADD_TEST(test_assign8 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign8')")
ADD_TEST(test_assign9 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/array" "-f" "wrap_test('test_assign9')")

=== tests/binary/CMakeLists.txt ===
ENABLE_TESTING()
ADD_TEST(test_bitand1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/binary" "-f" "wrap_test('test_bitand1')")
ADD_TEST(test_bitor1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/binary" "-f" "wrap_test('test_bitor1')")
ADD_TEST(test_bitxor1 ${FreeMat_Loc} "-e" "-nogui" "-t" "-nogreet" "-p" "${CMAKE_SOURCE_DIR}/tests/binary" "-f" "wrap_test('test_bitxor1')")

=== debian/changelog ===
freemat (4.2+dfsg1-6) unstable; urgency=medium

  * [b63cedd] Remove myself from uploaders
  * [7064293] Remove Giuseppe from uploaders. (Closes: #866842)

 -- Anton Gladky <gladk@debian.org>  Fri, 02 Feb 2018 22:57:21 +0100

freemat (4.2+dfsg1-5) unstable; urgency=medium

  * Team upload
  * [f822a68] Disable tests, failing on mips*
  * [1cbe414] Bump standards-version 4.0.0

 -- Anton Gladky <gladk@debian.org>  Fri, 21 Jul 2017 21:43:06 +0200

freemat (4.2+dfsg1-5~exp1) experimental; urgency=medium

  [ Graham Inggs ]
  * [b26ea52] Enable build-time tests. (Closes: #863793)
  * [3a715a3] Enable autopkgtests
  * [e8c9c79] Skip build-time tests on s390x
  * [0b8cf01] Restore missing files, enable diff() and hist() tests.
              (Closes: #864364)
  * [7c38fbe] Fix version displayed in Help->About
  * [0bff2da] Disable update check
  * [f36da0e] Fix failure to start if ~/Private exists. (Closes: #863795)

  [ Anton Gladky ]
  * [bfbc168] Switch to compat-level 10.
  * [a6ae5a0] Enable maximal hardening.
  * [08fe1a7] Add xauth to build-depends.
  * [253b815] Replace XS-Autobuild by Testsuite in d/control.
  * [da56e36] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Thu, 08 Jun 2017 20:52:33 +0200

freemat (4.2+dfsg1-4) unstable; urgency=medium

  [ Graham Inggs ]
  * [d62fa98] Fix Vcs-Git URI

  [ Anton Gladky ]
  * [51ba71b] Disable LLVM-support. (Closes: #863686)

 -- Anton Gladky <gladk@debian.org>  Tue, 30 May 2017 21:33:54 +0200

freemat (4.2+dfsg1-3) unstable; urgency=medium

  * Team upload
  * Rename 'FreeMat v4.0.conf' to 'FreeMat v4.2.conf'
  * Move '/etc/xdg/FreeMat/FreeMat v4.0.conf' to
    '/etc/xdg/FreeMat/FreeMat v4.2.conf' without triggering a dpkg
    question
  * Use freemat_small_mod_64.png as the icon instead of freemat-2.xpm
  * Use secure URI for Vcs-Git
  * Bump Standards-Version to 3.9.8, no changes

 -- Graham Inggs <ginggs@debian.org>  Sat, 08 Oct 2016 15:51:14 +0200

freemat (4.2+dfsg1-2) unstable; urgency=medium

  * Team upload

  [ Graham Inggs ]
  * debian/patches/fix-llvm-build.patch:
    - fix build failure with default llvm 3.8 (Closes: #833667)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Oct 2016 10:01:50 +0200

freemat (4.2+dfsg1-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Anton Gladky <gladk@debian.org>  Tue, 05 Apr 2016 22:55:56 +0200

freemat (4.2+dfsg1-1~exp1) experimental; urgency=medium

  * [98fecdc] Update d/watch.
  * [9c8731a] Add Files-Excluded to d/copyright.
  * [21c1597] Use packaged jquery.js.
  * [9c7a3c2] Update list of BDs.
  * [af342be] Apply cme fix dpkg.
  * [5a783e5] Update, remove patches.
  * [d00130d] Update version in .install and rules.
  * [8b25b9d] Remove qtwebkit:disables help-menu functionality,
              needs to be ported to Qt5.
  * [361d37e] Remove menu-file.
  * [679b7f2] Update d/copyright.
  * [3804b3b] Imported Upstream version 4.2+dfsg1

 -- Anton Gladky <gladk@debian.org>  Tue, 26 Jan 2016 10:16:18 +0100

=== debian/control ===
Source: freemat
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Section: math
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 10),
               autotools-dev,
               autoconf,
               automake,
               gfortran,
               libpcre3-dev,
               libncurses5-dev,
               libfftw3-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               python-all-dev,
               llvm-dev,
               doxygen,
               libsuitesparse-dev,
               zlib1g-dev,
               portaudio19-dev,
               libglu1-mesa-dev,
               libffi-dev,
               libboost-math-dev,
               minpack-dev,
               pkg-config,
               libarpack2-dev,
               cmake,
               libvolpack1-dev,
               libclang-dev,
               libedit-dev,
               xvfb,
               xauth
Build-Depends-Indep: texlive
Build-Conflicts: libqt3-dev
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/freemat.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/freemat.git
Homepage: http://freemat.sourceforge.net

Package: freemat
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         freemat-data (= ${source:Version})
Recommends: freemat-help
Description: mathematics framework (mostly matlab compatible)
 FreeMat is a free environment for rapid engineering and scientific prototyping
 and data processing. It is similar to commercial systems such as MATLAB from
 Mathworks, and IDL from Research Systems, but is Open Source.
 FreeMat is available under the GPL license.

Package: freemat-data
Architecture: all
Depends: ${misc:Depends}
Recommends: freemat
Description: freemat data files
 FreeMat is a free environment for rapid engineering and scientific prototyping
 and data processing. It is similar to commercial systems such as MATLAB from
 Mathworks, and IDL from Research Systems, but is Open Source.
 FreeMat is available under the GPL license.
 .
 This package install freemat data files

Package: freemat-help
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery
Recommends: freemat
Description: freemat help files
 FreeMat is a free environment for rapid engineering and scientific prototyping
 and data processing. It is similar to commercial systems such as MATLAB from
 Mathworks, and IDL from Research Systems, but is Open Source.
 FreeMat is available under the GPL license.
 .
 This package install freemat help files

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = $(CURDIR)/debian/build
export HOME=$(BUILDDIR)
export DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)

extra_flags = \
  -DCMAKE_INSTALL_PREFIX=/usr  \
  -DRESOURCEDIR=/usr/share/freemat \
  -DCMAKE_BUILD_TYPE=Release \
  -DCMAKE_C_FLAGS="-Wall $(shell dpkg-buildflags --get CFLAGS)" \
  -DCMAKE_C_FLAGS_DEBUG="-Wall $(shell dpkg-buildflags --get CFLAGS)" \
  -DCMAKE_C_FLAGS_RELEASE="-Wall $(shell dpkg-buildflags --get CFLAGS) -DNDEBUG" \
  -DCMAKE_SKIP_RPATH=ON \
  -DUSE_LLVM=ON \
  -DFORCE_BUNDLED_PCRE=OFF \
  -DFORCE_BUNDLED_UMFPACK=OFF \
  -DFORCE_BUNDLED_PORTAUDIO=OFF \
  -DFORCE_BUNDLED_ZLIB=OFF \
  -DFORCE_BUNDLED_AMD=OFF

override_dh_auto_clean:
	dh_auto_clean
	dh_clean CMakeCache.txt dependencies/volpack-1.0c7/config.log dependencies/volpack-1.0c7/config.status debian/freemat.png
	find . -name '*.moc.cpp' -delete
	rm -rf $(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	cp images/freemat_small_mod_64.png debian/freemat.png

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_install-arch:
	mv debian/tmp/usr/bin/FreeMat debian/tmp/usr/bin/freemat
	dh_install -a

override_dh_auto_test:
	# Run FreeMat once in install mode to set toolbox path
	$(BUILDDIR)/src/FreeMat -i $(CURDIR)
ifeq (,$(filter $(DEB_HOST_ARCH),s390x))
	# Run test suite in virtual framebuffer, excluding JIT tests
	xvfb-run dh_auto_test --max-parallel=1 -- ARGS+="-E jit"
endif

=== debian/tests/control ===
Tests: testsuite
Restrictions: allow-stderr
Depends: freemat, @builddeps@

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg1,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb|-dfsg)\d*$// \
http://sf.net/freemat/FreeMat-(\d\S*)-Source\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
